Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPerspectiveTransform Class Reference

`#include <vtkPerspectiveTransform.h>`

Inheritance diagram for vtkPerspectiveTransform:

[legend]
Collaboration diagram for vtkPerspectiveTransform:

[legend]
List of all members.

## Detailed Description

describes a 4x4 matrix transformation

Date:
  2002/12/26 18:24:21

Revision:
  1.30

A vtkPerspectiveTransform can be used to describe the full range of homogeneous transformations. It was designed in particular to describe a camera-view of a scene.

The order in which you set up the display coordinates (via AdjustZBuffer() and AdjustViewport()), the projection (via Perspective(), Frustum(), or Ortho()) and the camera view (via SetupCamera()) are important. If the transform is in PreMultiply mode, which is the default, set the Viewport and ZBuffer first, then the projection, and finally the camera view. Once the view is set up, the Translate and Rotate methods can be used to move the camera around in world coordinates. If the Oblique() or Stereo() methods are used, they should be called just before SetupCamera().

In PostMultiply mode, you must perform all transformations in the opposite order. This is necessary, for example, if you already have a perspective transformation set up but must adjust the viewport. Another example is if you have a view transformation, and wish to perform translations and rotations in the camera's coordinate system rather than in world coordinates.

The SetInput and Concatenate methods can be used to create a transformation pipeline with vtkPerspectiveTransform. See vtkTransform for more information on the transformation pipeline.

See also:
  vtkGeneralTransform vtkTransform vtkMatrix4x4 vtkCamera

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (92%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkPerspectiveTransform.h)`
  - .`cxx` (`/Common/vtkPerspectiveTransform.cxx)`

Tests:
  vtkPerspectiveTransform (Tests)

Definition at line 68 of file vtkPerspectiveTransform.h.

## Public Types
typedef vtkHomogeneousTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Identity ()
void | Inverse ()
void | Perspective (double angle, double aspect, double znear, double zfar)
void | Shear (double dxdz, double dydz, double zplane)
void | Stereo (double angle, double focaldistance)
void | SetupCamera (double p0, double p1, double p2, double fp0, double fp1, double fp2, double vup0, double vup1, double vup2)
void | Concatenate (vtkHomogeneousTransform *transform)
vtkAbstractTransform * | MakeTransform ()
int | CircuitCheck (vtkAbstractTransform *transform)
unsigned long | GetMTime ()
void | AdjustViewport (double oldXMin, double oldXMax, double oldYMin, double oldYMax, double newXMin, double newXMax, double newYMin, double newYMax)
void | AdjustZBuffer (double oldNearZ, double oldFarZ, double newNearZ, double newFarZ)
void | Ortho (double xmin, double xmax, double ymin, double ymax, double znear, double zfar)
void | Frustum (double xmin, double xmax, double ymin, double ymax, double znear, double zfar)
void | SetupCamera (const double position[3], const double focalpoint[3], const double viewup[3])
void | Translate (double x, double y, double z)
void | Translate (const double x[3])
void | Translate (const float x[3])
void | RotateWXYZ (double angle, double x, double y, double z)
void | RotateWXYZ (double angle, const double axis[3])
void | RotateWXYZ (double angle, const float axis[3])
void | RotateX (double angle)
void | RotateY (double angle)
void | RotateZ (double angle)
void | Scale (double x, double y, double z)
void | Scale (const double s[3])
void | Scale (const float s[3])
void | SetMatrix (vtkMatrix4x4 *matrix)
void | SetMatrix (const double elements[16])
void | Concatenate (vtkMatrix4x4 *matrix)
void | Concatenate (const double elements[16])
void | PreMultiply ()
void | PostMultiply ()
int | GetNumberOfConcatenatedTransforms ()
vtkHomogeneousTransform * | GetConcatenatedTransform (int i)
void | SetInput (vtkHomogeneousTransform *input)
vtkHomogeneousTransform * | GetInput ()
int | GetInverseFlag ()
void | Push ()
void | Pop ()
## Static Public Methods
vtkPerspectiveTransform * | New ()
int | IsTypeOf (const char *type)
vtkPerspectiveTransform * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkPerspectiveTransform ()
| ~vtkPerspectiveTransform ()
void | InternalDeepCopy (vtkAbstractTransform *t)
void | InternalUpdate ()
## Protected Attributes
vtkHomogeneousTransform * | Input
vtkTransformConcatenation * | Concatenation
vtkTransformConcatenationStack * | Stack

## Member Typedef Documentation

typedef vtkHomogeneousTransform vtkPerspectiveTransform::Superclass

| Reimplemented from vtkHomogeneousTransform. Definition at line 72 of file vtkPerspectiveTransform.h.

## Constructor & Destructor Documentation

vtkPerspectiveTransform::vtkPerspectiveTransform | ( |  | ) | `[protected]`

vtkPerspectiveTransform::~vtkPerspectiveTransform | ( |  | ) | `[protected]`

## Member Function Documentation

vtkPerspectiveTransform* vtkPerspectiveTransform::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkPerspectiveTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkHomogeneousTransform.

int vtkPerspectiveTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkHomogeneousTransform.

virtual int vtkPerspectiveTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkHomogeneousTransform.

vtkPerspectiveTransform* vtkPerspectiveTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkHomogeneousTransform.

void vtkPerspectiveTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkHomogeneousTransform.

void vtkPerspectiveTransform::Identity | ( |  | ) | `[inline]`

| Set this transformation to the identity transformation. If the transform has an Input, then the transformation will be reset so that it is the same as the Input. Reimplemented from vtkAbstractTransform. Definition at line 78 of file vtkPerspectiveTransform.h. References vtkObject::Modified().

void vtkPerspectiveTransform::Inverse | ( |  | ) | `[inline, virtual]`

| Invert the transformation. This will also set a flag so that the transformation will use the inverse of its Input, if an Input has been set. Implements vtkAbstractTransform. Definition at line 83 of file vtkPerspectiveTransform.h. References vtkObject::Modified().

void vtkPerspectiveTransform::AdjustViewport | ( | double | oldXMin,
|  | double | oldXMax,
|  | double | oldYMin,
|  | double | oldYMax,
|  | double | newXMin,
|  | double | newXMax,
|  | double | newYMin,
|  | double | newYMax
| ) |

| Perform an adjustment to the viewport coordinates. By default Ortho, Frustum, and Perspective provide a window of ([-1,+1],[-1,+1]). In PreMultiply mode, you call this method before calling Ortho, Frustum, or Perspective. In PostMultiply mode you can call it after. Note that if you must apply both AdjustZBuffer and AdjustViewport, it makes no difference which order you apply them in.

void vtkPerspectiveTransform::AdjustZBuffer | ( | double | oldNearZ,
|  | double | oldFarZ,
|  | double | newNearZ,
|  | double | newFarZ
| ) |

| Perform an adjustment to the Z-Buffer range that the near and far clipping planes map to. By default Ortho, Frustum, and Perspective map the near clipping plane to -1 and the far clipping plane to +1. In PreMultiply mode, you call this method before calling Ortho, Frustum, or Perspective. In PostMultiply mode you can call it after.

void vtkPerspectiveTransform::Ortho | ( | double | xmin,
|  | double | xmax,
|  | double | ymin,
|  | double | ymax,
|  | double | znear,
|  | double | zfar
| ) |

| Create an orthogonal projection matrix and concatenate it by the current transformation. The matrix maps [xmin,xmax], [ymin,ymax], [-znear,-zfar] to [-1,+1], [-1,+1], [+1,-1].

void vtkPerspectiveTransform::Frustum | ( | double | xmin,
|  | double | xmax,
|  | double | ymin,
|  | double | ymax,
|  | double | znear,
|  | double | zfar
| ) |

| Create an perspective projection matrix and concatenate it by the current transformation. The matrix maps a frustum with a back plane at -zfar and a front plane at -znear with extent [xmin,xmax],[ymin,ymax] to [-1,+1], [-1,+1], [+1,-1].

void vtkPerspectiveTransform::Perspective | ( | double | angle,
|  | double | aspect,
|  | double | znear,
|  | double | zfar
| ) |

| Create a perspective projection matrix by specifying the view angle (this angle is in the y direction), the aspect ratio, and the near and far clipping range. The projection matrix is concatenated with the current transformation. This method works via Frustum.

void vtkPerspectiveTransform::Shear | ( | double | dxdz,
|  | double | dydz,
|  | double | zplane
| ) |

| Create a shear transformation about a plane at distance z from the camera. The values dxdz (i.e. dx/dz) and dydz specify the amount of shear in the x and y directions. The 'zplane' specifies the distance from the camera to the plane at which the shear causes zero displacement. Generally you want this plane to be the focal plane. This transformation can be used in combination with Ortho to create an oblique projection. It can also be used in combination with Perspective to provide correct stereo views when the eye is at arbitrary but known positions relative to the center of a flat viewing screen.

void vtkPerspectiveTransform::Stereo | ( | double | angle,
|  | double | focaldistance
| ) |

| Create a stereo shear matrix and concatenate it with the current transformation. This can be applied in conjunction with either a perspective transformation (via Frustum or Projection) or an orthographic projection. You must specify the distance from the camera plane to the focal plane, and the angle between the distance vector and the eye. The angle should be negative for the left eye, and positive for the right. This method works via Oblique.

void vtkPerspectiveTransform::SetupCamera | ( | const double | position[3],
|  | const double | focalpoint[3],
|  | const double | viewup[3]
| ) |

| Set a view transformation matrix for the camera (this matrix does not contain any perspective) and concatenate it with the current transformation.

void vtkPerspectiveTransform::SetupCamera | ( | double | p0,
|  | double | p1,
|  | double | p2,
|  | double | fp0,
|  | double | fp1,
|  | double | fp2,
|  | double | vup0,
|  | double | vup1,
|  | double | vup2
| ) |

void vtkPerspectiveTransform::Translate | ( | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 167 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Translate | ( | const double | x[3] | ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 169 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Translate | ( | const float | x[3] | ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 170 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::RotateWXYZ | ( | double | angle,
|  | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 178 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::RotateWXYZ | ( | double | angle,
|  | const double | axis[3]
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 180 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::RotateWXYZ | ( | double | angle,
|  | const float | axis[3]
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 182 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::RotateX | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 190 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::RotateY | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 191 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::RotateZ | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 192 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Scale | ( | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 199 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Scale | ( | const double | s[3] | ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 201 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Scale | ( | const float | s[3] | ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 202 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::SetMatrix | ( | vtkMatrix4x4 * | matrix | ) | `[inline]`

| Set the current matrix directly. This actually calls Identity(), followed by Concatenate(matrix). Definition at line 208 of file vtkPerspectiveTransform.h. References vtkMatrix4x4::Element.

void vtkPerspectiveTransform::SetMatrix | ( | const double | elements[16] | ) | `[inline]`

| Set the current matrix directly. This actually calls Identity(), followed by Concatenate(matrix). Definition at line 210 of file vtkPerspectiveTransform.h. References vtkAbstractTransform::Identity().

void vtkPerspectiveTransform::Concatenate | ( | vtkMatrix4x4 * | matrix | ) | `[inline]`

| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 217 of file vtkPerspectiveTransform.h. References vtkMatrix4x4::Element.

void vtkPerspectiveTransform::Concatenate | ( | const double | elements[16] | ) | `[inline]`

| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 219 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Concatenate | ( | vtkHomogeneousTransform * | transform | ) |

| Concatenate the specified transform with the current transformation according to PreMultiply or PostMultiply semantics. The concatenation is pipelined, meaning that if any of the transformations are changed, even after Concatenate() is called, those changes will be reflected when you call TransformPoint().

void vtkPerspectiveTransform::PreMultiply | ( |  | ) | `[inline]`

| Sets the internal state of the transform to PreMultiply. All subsequent operations will occur before those already represented in the current transformation. In homogeneous matrix notation, M = M*A where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply. Definition at line 236 of file vtkPerspectiveTransform.h. References vtkObject::Modified().

void vtkPerspectiveTransform::PostMultiply | ( |  | ) | `[inline]`

| Sets the internal state of the transform to PostMultiply. All subsequent operations will occur after those already represented in the current transformation. In homogeneous matrix notation, M = A*M where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply. Definition at line 247 of file vtkPerspectiveTransform.h. References vtkObject::Modified().

int vtkPerspectiveTransform::GetNumberOfConcatenatedTransforms | ( |  | ) | `[inline]`

| Get the total number of transformations that are linked into this one via Concatenate() operations or via SetInput(). Definition at line 255 of file vtkPerspectiveTransform.h.

vtkHomogeneousTransform* vtkPerspectiveTransform::GetConcatenatedTransform | ( | int | i | ) | `[inline]`

| Get one of the concatenated transformations as a vtkAbstractTransform. These transformations are applied, in series, every time the transformation of a coordinate occurs. This method is provided to make it possible to decompose a transformation into its constituents, for example to save a transformation to a file. Definition at line 266 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::SetInput | ( | vtkHomogeneousTransform * | input | ) |

| Set the input for this transformation. This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input.

vtkHomogeneousTransform* vtkPerspectiveTransform::GetInput | ( |  | ) | `[inline]`

| Set the input for this transformation. This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input. Definition at line 287 of file vtkPerspectiveTransform.h.

int vtkPerspectiveTransform::GetInverseFlag | ( |  | ) | `[inline]`

| Get the inverse flag of the transformation. This controls whether it is the Input or the inverse of the Input that is used as the base transformation. The InverseFlag is flipped every time Inverse() is called. The InverseFlag is off when a transform is first created. Definition at line 295 of file vtkPerspectiveTransform.h.

void vtkPerspectiveTransform::Push | ( |  | ) | `[inline]`

| Pushes the current transformation onto the transformation stack. Definition at line 301 of file vtkPerspectiveTransform.h. References vtkObject::Modified(), and vtkTransformConcatenationStack::New().

void vtkPerspectiveTransform::Pop | ( |  | ) | `[inline]`

| Deletes the transformation on the top of the stack and sets the top to the next transformation on the stack. Definition at line 310 of file vtkPerspectiveTransform.h. References vtkObject::Modified().

vtkAbstractTransform* vtkPerspectiveTransform::MakeTransform | ( |  | ) | `[virtual]`

| Make a new transform of the same type -- you are responsible for deleting the transform when you are done with it. Implements vtkAbstractTransform.

int vtkPerspectiveTransform::CircuitCheck | ( | vtkAbstractTransform * | transform | ) | `[virtual]`

| Check for self-reference. Will return true if concatenating with the specified transform, setting it to be our inverse, or setting it to be our input will create a circular reference. CircuitCheck is automatically called by SetInput(), SetInverse(), and Concatenate(vtkXTransform *). Avoid using this function, it is experimental. Reimplemented from vtkAbstractTransform.

unsigned long vtkPerspectiveTransform::GetMTime | ( |  | ) | `[virtual]`

| Override GetMTime to account for input and concatenation. Reimplemented from vtkAbstractTransform.

void vtkPerspectiveTransform::InternalDeepCopy | ( | vtkAbstractTransform * | t | ) | `[protected, virtual]`

| Perform any subclass-specific DeepCopy. Reimplemented from vtkHomogeneousTransform.

void vtkPerspectiveTransform::InternalUpdate | ( |  | ) | `[protected, virtual]`

| Perform any subclass-specific Update. Reimplemented from vtkAbstractTransform.

## Member Data Documentation

vtkHomogeneousTransform* vtkPerspectiveTransform::Input`[protected]`

| Definition at line 337 of file vtkPerspectiveTransform.h.

vtkTransformConcatenation* vtkPerspectiveTransform::Concatenation`[protected]`

| Definition at line 338 of file vtkPerspectiveTransform.h.

vtkTransformConcatenationStack* vtkPerspectiveTransform::Stack`[protected]`

| Definition at line 339 of file vtkPerspectiveTransform.h.

The documentation for this class was generated from the following file:

- Common/vtkPerspectiveTransform.h